<template>
  <transition
    enter-active-class="animated fadeIn"
    appear
  >
    <div class="w-full">
      <h4 class="text-2xl font-normal flex justify-between items-center mb-4">
        <div class="flex-1">
          <ul class="list-reset">
            <li
              v-for="[param, value] of g1"
              :key="param"
              class="flex justify-end items-center"
            >
              <span class="text-sm mr-2">
                {{ param }}:
              </span>
              <span class="text-right font-bold">
                {{ value }}
              </span>
            </li>
          </ul>
        </div>

        <div class="mx-8">
          VS
        </div>

        <div class="flex-1">
          <ul class="list-reset">
            <li
              v-for="[param, value] of g2"
              :key="param"
            >
              <b>{{ value }}</b>
            </li>
          </ul>
        </div>
      </h4>

      <h5 class="font-normal border-b-2 text-lg pb-4 mb-4 flex flex-col items-center">
        <div class="mb-4">
          On:
        </div>

        <ul class="list-reset">
          <li
            v-for="[param, value] of context"
            :key="param"
          >
            <span class="text-sm">
              {{ param }}:
            </span>
            <span class="">
              {{ value }}
            </span>
          </li>
        </ul>
      </h5>

      <p class="mb-4">
        Agreement in this context is <b>{{ patternSim100 }}%</b> instead of {{ refSim100 }}%, which represents a <b>{{ Math.abs(change100) }}% {{ change100 > 0 ? 'increase' : 'decrease' }}</b>.
      </p>

      <div class="flex-center">
        <div
          @click="select(selectedEntityPosition - 1)"
        >
          <icon
            name="chevron-left"
            class="mr-1 cursor-pointer"
          />
        </div>

        <div
          v-for="(entity, index) of entities"
          :key="index"
          :class="{ 'grow': true, 'entity_square': true, 'entity_square--active': index == selectedEntityPosition }"
          :style="squareStyle(entity)"
          :title="makeTitle(entity)"
          @click="select(index)"
        />

        <div
          @click="select(selectedEntityPosition + 1)"
        >
          <icon
            name="chevron-right"
            class="ml-1 cursor-pointer"
          />
        </div>
      </div>

      <div class="border-b-2 my-4" />

      <div
        v-if="selectedEntity"
        class="overflow-hidden relative"
      >
        <transition
          mode="out-in"
          :enter-active-class="[ 'animated fast fadeIn', headerAnimation.enter ].join(' ')"
          :leave-active-class="[ 'animated fast fadeOut', headerAnimation.leave ].join(' ')"
        >
          <div :key="selectedEntity.id">

            <EntityHeaderEUParl
              v-if="dataType == 'euparl'"
              class="my-4 text-center"
              :entity="selectedEntity"
            />

            <EntityHeaderCHUS
              v-else
              class="my-4 text-center"
              :entity="selectedEntity"
            />

            <div class="flex">
              <div class="w-1/2 mr-12">
                <p class="mb-4">
                  {{ summarizeGroup(group1) }}
                </p>

                <template v-if="dataType == 'euparl'">
                  <GroupMemberEUParl
                    v-for="m of group1"
                    :key="m.person[0]"
                    :member="m"
                  />
                </template>

                <template v-else>
                  <GroupMemberCHUS
                    v-for="m of group1"
                    :key="m.person[0]"
                    :member="m"
                  />
                </template>
              </div>

              <div class="w-1/2 ml-12">
                <p class="text-right mb-4">
                  {{ summarizeGroup(group2) }}
                </p>

                <template v-if="dataType == 'euparl'">
                  <GroupMemberEUParl
                    v-for="m of group2"
                    :key="m.person[0]"
                    :member="m"
                  />
                </template>

                <template v-else>
                  <GroupMemberCHUS
                    v-for="m of group2"
                    :key="m.person[0]"
                    :member="m"
                  />
                </template>
              </div>
            </div>
          </div>
        </transition>
      </div>
    </div>
  </transition>
</template>

<style scoped lang="postcss">
.entity_square {
  @apply block border border-black cursor-pointer;
  width: 20px;
  height: 20px;
  transition: all .2s;
}

.entity_square--active {
  box-shadow: inset 0 0 0 2px white;
}

.move {
  transition: transform .5s;
}
</style>

<script lang="tsx">
import { Vue, Component, Prop, Watch } from 'vue-property-decorator'
import { State } from 'vuex-class'

import 'vue-awesome/icons/chevron-left'
import 'vue-awesome/icons/chevron-right'
import Icon from 'vue-awesome/components/Icon.vue'

import axios from 'axios'
import * as _ from 'lodash/fp'

function colorPercentage ([r1, g1, b1], [r2, g2, b2], percentage) {
  const percent = (a, b) => a + (b - a) * percentage
  return [percent(r1, r2), percent(g1, g2), percent(b1, b2)]
}

function voteColorEUParl (vote) {
  switch (vote) {
    case 'For':
      return {
        background: 'bg-green-dark',
        text: 'text-white'
      }
    case 'Against':
      return {
        background: 'bg-red',
        text: 'text-white'
      }
    default:
      return {
        background: '',
        text: 'text-grey'
      }
  }
}

function voteColorCHUS (vote) {
  switch (vote) {
    case 'Yea':
      return {
        background: 'bg-green-dark',
        text: 'text-white'
      }
    case 'Nay':
      return {
        background: 'bg-red',
        text: 'text-white'
      }
    default:
      return {
        background: '',
        text: 'text-grey'
      }
  }
}

const GroupMemberEUParl = Vue.extend({
  functional: true,

  props: {
    member: {
      type: Object,
      required: true
    },
    inverted: {
      type: Boolean,
      default: false
    }
  },

  render (h, { props }) {
    // eslint-disable-next-line no-unused-vars
    const { person: [id, birthdate, country, currency, euMemberSince, gdp, gender, geosize, group, languages, name, party], vote } = props.member

    const animatedVote = (
      <transition
        mode='out-in'
        enter-active-class={[ 'animated fast', props.inverted ? 'fadeInRight' : 'fadeInLeft' ].join(' ')}
        leave-active-class={[ 'animated fast', props.inverted ? 'fadeOutRight' : 'fadeOutLeft' ].join(' ')}
      >
        <div
          key={vote}
          class={voteColorEUParl(vote).background + ' flex w-24 p-4 justify-center items-center'}
        >
          <span class={voteColorEUParl(vote).text}>
            { vote }
          </span>
        </div>
      </transition>
    )

    const details = (
      <div class={{ 'text-right': props.inverted }}>
        <div>
          <p class='font-bold'>{ name }</p>
          <p class='italic'>{ party } — { group }</p>
          <p>{ country }</p>
        </div>
      </div>
    )

    return (
      <div key={ id } class='flex justify-between border-b mb-2'>
        { props.inverted
          ? [ animatedVote, details ]
          : [ details, animatedVote ] }
      </div>
    )
  }
})

const GroupMemberCHUS = Vue.extend({
  functional: true,

  props: {
    member: {
      type: Object,
      required: true
    },
    inverted: {
      type: Boolean,
      default: false
    }
  },

  render (h, { props }) {
    // eslint-disable-next-line no-unused-vars
    const { person: [icpsr, bioname, congress, districtCode, occupancy, partyCode, stateAbbrev, stateIcpsr], vote } = props.member

    const displayVote = (
      <div
        key={vote}
        class={voteColorCHUS(vote).background + ' flex w-24 p-4 justify-center items-center'}
      >
        <span class={voteColorCHUS(vote).text}>
          { vote }
        </span>
      </div>
    )

    const details = (
      <div class={{ 'text-right': props.inverted }}>
        <div>
          <p class='font-bold'>{ bioname }</p>
          <p class='italic'>{ partyCode }</p>
          <p>{ stateAbbrev }</p>
        </div>
      </div>
    )

    return (
      <div key={ icpsr } class='flex justify-between border-b mb-2'>
        { props.inverted
          ? [ displayVote, details ]
          : [ details, displayVote ] }
      </div>
    )
  }
})

@Component
class EntityHeaderEUParl extends Vue {
  @Prop(Object) entity

  render () {
    const colors = voteColorEUParl(this.entity.majorityVote)
    return (
      <div>
        <h4 class='mb-2'>
          { this.entity.procedureTitle } (<a target='_blank' href={ this.entity.link }>link</a>)
        </h4>

        <p class=''>{ this.entity.issueType }</p>

        <p class='italic mb-4'>{ this.entity.voteDateDetailed }</p>

        <p>
          Parliament voted
          <span
            style='transition: background-color 1s'
            class={[ 'inline-block p-2 mx-1', colors.background, colors.text ]}>
            { this.entity.majorityVote }
          </span>
          this (For: { this.entity.majorityVoteDistribution[0] }, Against: { this.entity.majorityVoteDistribution[1] }, Abstain: { this.entity.majorityVoteDistribution[2] })
        </p>
      </div>
    )
  }
}

@Component
class EntityHeaderCHUS extends Vue {
  @Prop(Object) entity

  render (h) {
    const colors = voteColorCHUS(this.entity.majorityVote)
    const [nay, yea] = JSON.parse(this.entity.majorityVoteDistribution)

    return (
      <div>
        <h4 class='mb-2'>
          { this.entity.description }
        </h4>

        <p class=''>{ this.entity.issueType }</p>

        <p>
          Parliament voted
          <span
            style='transition: background-color 1s'
            class={[ 'inline-block p-2 mx-1', colors.background, colors.text ]}>
            { this.entity.majorityVote }
          </span>
          this (Nay: { nay }, Yea: { yea })
        </p>
      </div>
    )
  }
}

const headerAnimations = {
  left: { enter: 'fadeInLeft', leave: 'fadeOutRight' },
  right: { enter: 'fadeInRight', leave: 'fadeOutLeft' }
}

@Component({
  components: {
    EntityHeaderEUParl,
    EntityHeaderCHUS,
    GroupMemberEUParl,
    GroupMemberCHUS,
    Icon
  }
})
export default class DetailedResults extends Vue {
  get id () {
    return this.pattern.index
  }

  get context () {
    return this.pattern.context
  }

  get g1 () {
    return this.pattern.g1
  }

  get g2 () {
    return this.pattern.g2
  }

  get refSim () {
    return this.pattern.refSim
  }

  get refSim100 () {
    return Math.round(this.refSim * 100)
  }

  get patternSim () {
    return this.pattern.patternSim
  }

  get patternSim100 () {
    return Math.round(this.patternSim * 100)
  }

  get change100 () {
    return Math.round((this.patternSim - this.refSim) / this.refSim * 100)
  }

  get group1 () {
    return this.aggregate(this.g1Data, _.get(this.selectedEntity.id, this.g1Outcomes))
  }

  get group2 () {
    return this.aggregate(this.g2Data, _.get(this.selectedEntity.id, this.g2Outcomes))
  }

  get selectedEntity () {
    if (_.isEmpty(this.entities)) {
      return null
    }

    switch (this.dataType) {
      case 'euparl': {
        const [
          id,
          committee,
          dossierid,
          issueType,
          link,
          procedureSubject,
          procedureSubtype,
          procedureTitle,
          procedureType,
          voteDate,
          voteDateDetailed,
          sim,
          majorityVote,
          majorityVoteDistribution
        ] = this.entities[this.selectedEntityPosition]
        return {
          id,
          committee,
          dossierid,
          issueType,
          link,
          procedureSubject,
          procedureSubtype,
          procedureTitle,
          procedureType,
          voteDate,
          voteDateDetailed,
          sim,
          majorityVote,
          majorityVoteDistribution: JSON.parse(majorityVoteDistribution)
        }
      }
      case 'chus': {
        const [ id, billtype, congress, description, topic, idInCongress, year, sim, majorityVote, majorityVoteDistribution ] = this.entities[this.selectedEntityPosition]

        return {
          id, billtype, congress, description, topic, idInCongress, year, sim, majorityVote, majorityVoteDistribution
        }
      }
    }
  }
  @Prop(Object) pattern
  @Prop(String) dataType

  @State userID
  @State jobID

  entities = []
  g1Data = []
  g1Outcomes = {}
  g2Data = []
  g2Outcomes = {}
  selectedEntityPosition = 0
  headerAnimation = headerAnimations.right

  @Watch('id')
  onIdChanged () {
    this.getDetailedResults(this.id)
  }

  mounted () {
    document.addEventListener('keyup', this.navigate)
    this.getDetailedResults(this.id)
  }

  destroyed () {
    document.removeEventListener('keyup', this.navigate)
  }

  makeTitle (entity) {
    return `${entity[7]}
${entity[6]}`
  }

  getDetailedResults (id) {
    axios.get(`/api/results/${this.userID}/${this.jobID}/${id}`)
      .then(({
        data: {
          entities,
          g1,
          g1_outcomes: g1Outcomes,
          g2,
          g2_outcomes: g2Outcomes
        }
      }) => {
        switch (this.dataType) {
          case 'euparl': {
            this.entities = _.tail(entities).sort((a, b) => b[11] - a[11])
            break
          }
          case 'chus': {
            this.entities = _.tail(entities).sort((a, b) => b[7] - a[7])
            break
          }
        }
        this.g1Data = _.tail(g1)
        this.g2Data = _.tail(g2)
        this.g1Outcomes = {}
        this.g2Outcomes = {}

        for (const voteId of this.entities.map(_.head)) {
          this.g1Outcomes[voteId as number] = {}
          this.g2Outcomes[voteId as number] = {}
        }

        for (const [voteId, voterId, vote] of _.tail(g1Outcomes) as Array<[number, number, string]>) {
          if (!this.g1Outcomes[voteId]) {
            this.g1Outcomes[voteId] = {}
          }
          this.g1Outcomes[voteId][voterId] = vote
        }

        for (const [voteId, voterId, vote] of _.tail(g2Outcomes) as Array<[number, number, string]>) {
          if (!this.g2Outcomes[voteId]) {
            this.g2Outcomes[voteId] = {}
          }
          this.g2Outcomes[voteId][voterId] = vote
        }
      })
  }

  select (i) {
    this.headerAnimation = _.get(i < this.selectedEntityPosition ? 'left' : 'right', headerAnimations)
    this.selectedEntityPosition = _.clamp(0, this.entities.length - 1, i)
  }

  navigate ({
    keyCode
  }) {
    const arrow = {
      left: 37,
      up: 38,
      right: 39,
      down: 40
    }

    switch (keyCode) {
      case arrow.left:
        this.select(this.selectedEntityPosition - 1)
        break
      case arrow.right:
        this.select(this.selectedEntityPosition + 1)
        break
    }
  }

  summarizeGroup (group) {
    const totals = group.reduce((totals, {
      vote
    }) => {
      totals[vote] = (totals[vote] || 0) + 1
      return totals
    }, {})
    return Object.keys(totals)
      .map((key) => `${key}: ${totals[key]}`)
      .join(', ')
      .replace('-', 'Absentee')
  }

  aggregate (group, outcomes) {
    return _.compose([
      _.reverse,
      _.filter(_.get('vote')),
      _.sortBy(_.get('vote')),
      _.map((person) => ({
        person,
        vote: outcomes[person[0]]
      }))
    ])(group)
  }

  squareStyle (entity) {
    switch (this.dataType) {
      case 'euparl': {
        return `background: rgb(${colorPercentage([221, 75, 57], [0, 166, 90], entity[11]).join(',')});`
      }
      case 'chus': {
        return `background: rgb(${colorPercentage([221, 75, 57], [0, 166, 90], entity[7]).join(',')});`
      }
    }
  }
}
</script>
